# ModifyBackend

## 1. API Description

This API (ModifyBackend) is used to modify the configurations of one or more backend servers added to a specified listener, including the weight and forwarding port.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type                                                                                                             | Description                             |
| -------------- | -------- | ---------------------------------------------------------------------------------------------------------------- | --------------------------------------- |
| loadBalancerId | Yes      | String                                                                                                           | Load balance instance ID.               |
| listenerId     | Yes      | String                                                                                                           | The listener ID of the load balancer.   |
| backendServers | Yes      | Array of [BackendServer](https://docs.console.zenlayer.com/api-reference/networking/datastructure#backendserver) | List of backend servers to be modified. |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Modify the weight and port of the backend server added to a listener.**

```json
POST /api/v2/zlb HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: ModifyBackend
<Common Request Params>

Request：
{
  "loadBalancerId" : "<loadBalancerId>",
  "listenerId" : "<listenerId>",
  "backendServers" : [
    {
      "instanceId" : "<backendServerId>",
      "privateIpAddress": "10.0.0.1",
      "weight": "50",
      "port": 10
    }
  ]
}

Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](https://docs.console.zenlayer.com/api-reference/api-introduction/toolkit/api-sdk)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](https://docs.console.zenlayer.com/api-reference/api-introduction/instruction/commonerrorcode).

| HTTP Status Code | Error Code                        | Description                                                                                         |
| ---------------- | --------------------------------- | --------------------------------------------------------------------------------------------------- |
| 400              | INVALID\_BACKEND\_SERVER\_PORT    | In DR mode, full port, or listening on multiple ports, the backend server port cannot be specified. |
| 404              | INVALID\_LB\_LISTENER\_NOT\_FOUND | The listener does not exist.                                                                        |
| 404              | INVALID\_LISTENER\_RS\_NOT\_FOUND | Backend server not found for the listener.                                                          |
